
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>阿里云容器服务--自定义路由和负载均衡策略 / iVAN</title>

    <meta name="description" content="阿里云容器服务--自定义路由和负载均衡策略 简单示例 让我们先从一个简单的例子开始,我们会部署一个acs/proxy容器,容器前面配置一个slb实例,让大家可以访问,同时在后端挂上一个nginx,这里我们只展示nginx的首页. compose模板如下所示: lb: image: registry.aliyuncs.com/acs/proxy:0.5 ports: - '80:80' restart: always labels: # addon 使得proxy镜像有订阅注册中心的能力,动态加载服务的路由 aliyun.custom_ad">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">阿里云容器服务--自定义路由和负载均衡策略</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>简单示例</h1>
<p>让我们先从一个简单的例子开始，我们会部署一个acs/proxy容器，容器前面配置一个slb实例，让大家可以访问，同时在后端挂上一个nginx，这里我们只展示nginx的首页。 compose模板如下所示：</p>
<pre><code>lb:
    image:  registry.aliyuncs.com/acs/proxy:0.5
    ports:
            -  '80:80'
    restart:  always
    labels:
        # addon 使得proxy镜像有订阅注册中心的能力，动态加载服务的路由
        aliyun.custom_addon:  "proxy"
        # 每台vm 部署一个该镜像的容器
        aliyun.global:  "true"
        #  前端绑定SLB
        aliyun.lb.port_80: tcp://proxy_test:80
    environment:
        #  支持加载路由的后端容器的范围，"*"表示整个集群，默认为应用内的服务
        ADDITIONAL_SERVICES:  "*"
appone:
    expose:  # 被代理的服务一定要使用expose或者ports告诉proxy容器暴露哪个端口
        -  80/tcp
    image:  'nginx:latest'
    labels:
        #  此处支持http/https/ws/wss  协议，必须使用用户自己的域名而不是容器服务提供的测试域名
        aliyun.proxy.VIRTUAL_HOST:  "http://appone.example.com"
    restart:  always
</code></pre>
<p>服务启动成功后，页面如下图所示<br /><a href="https://yqfile.alicdn.com/306c6a0551abd37222b8ddeb797b8fae9fa3d34f.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzMwNmM2YTA1NTFhYmQzNzIyMmI4ZGRlYjc5N2I4ZmFlOWZhM2QzNGYucG5n.jpg"></a></p>
<h1>开启会话保持</h1>
<pre><code>lb:
    image:  registry.aliyuncs.com/acs/proxy:0.5
    ports:
            -  '80:80'
    restart:  always
    labels:
        # addon 使得proxy镜像有订阅注册中心的能力，动态加载服务的路由
        aliyun.custom_addon:  "proxy"
        # 每台vm 部署一个该镜像的容器
        aliyun.global:  "true"
        #  前端绑定SLB
        aliyun.lb.port_80: tcp://proxy_test:80
    environment:
        #  支持加载路由的后端容器的范围，"*"表示整个集群，默认为应用内的服务
        ADDITIONAL_SERVICES:  "*"
appone:
    ports:
        -  80/tcp
        -  443/tcp
    image:  'nginx:latest'
    labels:
        #  此处支持http/https/ws/wss  协议
        aliyun.proxy.VIRTUAL_HOST:  "http://appone.example.com"
        # 此处支持会话保持，使用cookie的方式，键为 CONTAINERID
        aliyun.proxy.COOKIE: "CONTAINERID insert indirect"
    restart:  always
</code></pre>
<h1>自定义503页面</h1>
<p>当我们直接输入SLB的VIP地址而不是域名时，访问的页面如下图所示，返回503错误页面<br /><a href="https://yqfile.alicdn.com/ef479a48d98ea8ee38d1cb8245816526c6eed401.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2VmNDc5YTQ4ZDk4ZWE4ZWUzOGQxY2I4MjQ1ODE2NTI2YzZlZWQ0MDEucG5n.jpg"></a><br />
我们希望在503页面增加一些提示信息。在容器所在的vm增加文件夹/errors，同时增加文件/errors/503.http，文件内容如下：</p>
<pre><code>HTTP/1.0 503 Service Unavailable
Cache-Control: no-cache
Connection: close
Content-Type: text/html;charset=UTF-8

&lt;html&gt;&lt;body&gt;&lt;h1&gt;503 Service Unavailable&lt;/h1&gt;

&lt;h3&gt;No server is available to handle this request.&lt;/h3&gt;

&lt;h3&gt;如果您看到这个页面，说明您访问服务出现了问题，请按如下步骤排查解决问题：&lt;/h3&gt;
&lt;li&gt;如果您是应用的访问者，请寻求应用的维护者解决问题。&lt;/li&gt;
&lt;li&gt;如果您是应用的维护者，继续查看下面的信息。&lt;/li&gt;
&lt;li&gt;您现在使用的是简单路由服务，整个请求会从SLB -&gt; acsrouting应用容器 -&gt; 您的应用容器, 请按下列步骤排查。&lt;/li&gt;
&lt;li&gt;请登陆容器服务控制台，在左侧边栏选择"服务"，在"服务列表"选择相应的"集群"，点击暴露到公网的"服务"，查看服务的"访问端点"，仔细检查您的访问域名与在相应的服务中配置的域名是否一致。&lt;/li&gt;
&lt;li&gt;按照&lt;a href="https://help.aliyun.com/knowledge_detail/42660.html"&gt;简单路由服务链路排查&lt;/a&gt;进行问题定位和排查。&lt;/li&gt;
&lt;li&gt;查看&lt;a href="https://help.aliyun.com/knowledge_detail/42658.html"&gt;路由常见问题文档&lt;/a&gt;。&lt;/li&gt;
&lt;li&gt;如果上面的方式还没有解决您的问题，请&lt;a href="https://workorder.console.aliyun.com/#/ticket/add?productId=1254"&gt;提交工单&lt;/a&gt;，联系技术人员协助解决，我们会竭诚为您服务。&lt;/li&gt;
&lt;/body&gt;&lt;/html&gt;
</code></pre>
<p>你也可以修改为你展示的错误页面。修改compose模板如下：</p>
<pre><code>lb:
    image:  registry.aliyuncs.com/acs/proxy:0.5
    ports:
            -  '80:80'
    restart:  always
    labels:
        # addon 使得proxy镜像有订阅注册中心的能力，动态加载服务的路由
        aliyun.custom_addon:  "proxy"
        # 每台vm 部署一个该镜像的容器
        aliyun.global:  "true"
        #  前端绑定SLB
        aliyun.lb.port_80: tcp://proxy_test:80
    environment:
        #  支持加载路由的后端容器的范围，"*"表示整个集群，默认为应用内的服务
        ADDITIONAL_SERVICES:  "*"
        EXTRA_FRONTEND_SETTINGS_80: "errorfile 503 /usr/local/etc/haproxy/errors/503.http"
    volumes:
        - /errors/:/usr/local/etc/haproxy/errors/
appone:
    ports:
        -  80/tcp
        -  443/tcp
    image:  'nginx:latest'
    labels:
        #  配置url，支持指定path，此处支持http/https/ws/wss  协议
        aliyun.proxy.VIRTUAL_HOST:  "http://appone.example.com"
    restart:  always
</code></pre>
<p>输入SLB的VIP之后，显示的503页面如下图所示：<br /><a href="https://yqfile.alicdn.com/36d8f530645edd4c7eb968c9d58cc638778ea959.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzM2ZDhmNTMwNjQ1ZWRkNGM3ZWI5NjhjOWQ1OGNjNjM4Nzc4ZWE5NTkucG5n.jpg"></a></p>
<h1>支持泛域名</h1>
<p>我们希望nginx的后端支持泛域名，即appone.example.com能访问到nginx首页，*.example.com也能访问到nginx的首页，修改配置如下即可：</p>
<pre><code>lb:
    image:  registry.aliyuncs.com/acs/proxy:0.5
    ports:
            -  '80:80'
    restart:  always
    labels:
        # addon 使得proxy镜像有订阅注册中心的能力，动态加载服务的路由
        aliyun.custom_addon:  "proxy"
        # 每台vm 部署一个该镜像的容器
        aliyun.global:  "true"
        #  前端绑定SLB
        aliyun.lb.port_80: tcp://proxy_test:80
    environment:
        #  支持加载路由的后端容器的范围，"*"表示整个集群，默认为应用内的服务
        ADDITIONAL_SERVICES:  "*"
        EXTRA_FRONTEND_SETTINGS_80: "errorfile 503 /usr/local/etc/haproxy/errors/503.http"
    volumes:
        - /errors/:/usr/local/etc/haproxy/errors/
appone:
    ports:
        -  80/tcp
        -  443/tcp
    image:  'nginx:latest'
    labels:
        #  配置url，支持指定path，此处支持http/https/ws/wss  协议
        aliyun.proxy.VIRTUAL_HOST:  "http://*.example.com"
    restart:  always
</code></pre>
<p>绑定host，输入域名<code>www.example.com</code>之后，显示nginx首页如下图所示：<br /><a href="https://yqfile.alicdn.com/84af7b8ab58abb8b3ed8d5a2a369a43ab6571d82.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzg0YWY3YjhhYjU4YWJiOGIzZWQ4ZDVhMmEzNjlhNDNhYjY1NzFkODIucG5n.jpg"></a></p>
<h1>配置默认的后端</h1>
<p>有时候，我们希望直接通过IP也能访问到后端的nginx，把url配置去掉，把修改配置如下即可：</p>
<pre><code>lb:
    image:  registry.aliyuncs.com/acs/proxy:0.5
    ports:
            -  '80:80'
    restart:  always
    labels:
        # addon 使得proxy镜像有订阅注册中心的能力，动态加载服务的路由
        aliyun.custom_addon:  "proxy"
        # 每台vm 部署一个该镜像的容器
        aliyun.global:  "true"
        #  前端绑定SLB
        aliyun.lb.port_80: tcp://proxy_test:80
    environment:
        #  支持加载路由的后端容器的范围，"*"表示整个集群，默认为应用内的服务
        ADDITIONAL_SERVICES:  "*"

        # 返回503时，指定错误页面
        EXTRA_FRONTEND_SETTINGS_80: "errorfile 503 /usr/local/etc/haproxy/errors/503.http"
    volumes:
        # 从主机挂载错误页面到容器内部
        - /errors/:/usr/local/etc/haproxy/errors/
appone:
    ports:
        -  80/tcp
        -  443/tcp
    image:  'nginx:latest'
    labels:
        #  配置url，支持指定path，此处支持http/https/ws/wss  协议
        aliyun.proxy.required: "true"
    restart:  always
</code></pre>
<p>输入SLB的VIP之后，显示nginx首页如下图所示：<br /><a href="https://yqfile.alicdn.com/c2676d76fee3095f60b20ab1ce907e76f753d183.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2MyNjc2ZDc2ZmVlMzA5NWY2MGIyMGFiMWNlOTA3ZTc2Zjc1M2QxODMucG5n.jpg"></a></p>
<h1>url参数值选择后端</h1>
<p>有些用户希望能够根据url参数值不同的来代理不同的后端，以下示例将通过<a href="http://www.example.com?backend=appone" rel="external nofollow noreferrer">http://www.example.com?backend=appone</a> 访问服务appone，即nginx首页，通过<a href="http://www.example.com?backend=apptwo" rel="external nofollow noreferrer">http://www.example.com?backend=apptwo</a> 访问服务apptwo，即hello world首页。应用模板代码如下所示：</p>
<pre><code>lb:
    image:  registry.aliyuncs.com/acs/proxy:0.5
    ports:
            -  '80:80'
    restart:  always
    labels:
        # addon 使得proxy镜像有订阅注册中心的能力，动态加载服务的路由
        aliyun.custom_addon:  "proxy"
        # 每台vm 部署一个该镜像的容器
        aliyun.global:  "true"
        #  前端绑定SLB
        aliyun.lb.port_80: tcp://proxy_test:80
    environment:
        #  支持加载路由的后端容器的范围，"*"表示整个集群，默认为应用内的服务
        ADDITIONAL_SERVICES:  "*"
        #  获取url中参数名称为backend的参数值，同时将HOST header 修改为要匹配的后端的域名
        EXTRA_FRONTEND_SETTINGS_80:  "  http-request set-header HOST %[urlp(backend)].example.com"
appone:
    ports:
        -  80/tcp
        -  443/tcp
    image:  'nginx:latest'
    labels:
        #   配置url，支持指定path，此处支持http/https/ws/wss  协议
        aliyun.proxy.VIRTUAL_HOST:  "http://appone.example.com"
    restart:  always
apptwo:
    ports:
        -  80/tcp
    image:  'registry.cn-hangzhou.aliyuncs.com/linhuatest/hello-world:latest'
    labels:
        #   配置url，支持指定path，此处支持http/https/ws/wss  协议
        aliyun.proxy.VIRTUAL_HOST:  "http://apptwo.example.com"
    restart:  always
</code></pre>
<p>绑定host，输入链接<a href="http://www.example.com?backend=appone" rel="external nofollow noreferrer">http://www.example.com?backend=appone</a> ，显示服务appone的nginx首页，如下所示<br /><a href="https://yqfile.alicdn.com/0d23c443458a3492156a808e59f3b6e788731756.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzBkMjNjNDQzNDU4YTM0OTIxNTZhODA4ZTU5ZjNiNmU3ODg3MzE3NTYucG5n.jpg"></a><br />
绑定host，输入链接<a href="http://www.example.com?backend=apptwo" rel="external nofollow noreferrer">http://www.example.com?backend=apptwo</a> ，显示服务apptwo的hello world首页，如下所示<br /><a href="https://yqfile.alicdn.com/0f6de69ae52d4cdab613949d4a7e51f3f3e35e5a.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzBmNmRlNjlhZTUyZDRjZGFiNjEzOTQ5ZDRhN2U1MWYzZjNlMzVlNWEucG5n.jpg"></a></p>
<h1>记录访问日志</h1>
<pre><code>lb:
    image:  registry.aliyuncs.com/acs/proxy:0.5
    ports:
            -  '80:80'
    restart:  always
    labels:
        # addon 使得proxy镜像有订阅注册中心的能力，动态加载服务的路由
        aliyun.custom_addon:  "proxy"
        # 每台vm 部署一个该镜像的容器
        aliyun.global:  "true"
        #  前端绑定SLB
        aliyun.lb.port_80: tcp://proxy_test:80
    environment:
        #  支持加载路由的后端容器的范围，"*"表示整个集群，默认为应用内的服务
        ADDITIONAL_SERVICES:  "*"
        EXTRA_DEFAULT_SETTINGS: "log rsyslog local0,log global,option httplog"
    links:
        - rsyslog:rsyslog
rsyslog:
    image: registry.cn-hangzhou.aliyuncs.com/linhuatest/rsyslog:latest
appone:
    ports:
        -  80/tcp
        -  443/tcp
    image:  'nginx:latest'
    labels:
        #  此处支持http/https/ws/wss  协议
        aliyun.proxy.VIRTUAL_HOST:  "http://appone.example.com"
    restart:  always
</code></pre>
<p>日志会直接打到rsyslog容器的标准输出中，通过<code>docker logs $rsyslog_container_name</code> 即能看到自定义路由的访问日志</p>
<h1>服务间的负载均衡</h1>
<p>以下模板创建一个负载均衡服务<code>lb</code>和一个应用服务<code>appone</code>，整体对外提供域名为appone.example.com的服务</p>
<pre><code>lb:
    image:  registry.aliyuncs.com/acs/proxy:0.5
    hostname: proxy  # 指定该服务的域名为proxy，即proxy会解析到所有部署了该镜像的容器
    ports:
            -  '80:80'
    restart:  always
    labels:
        # addon 使得proxy镜像有订阅注册中心的能力，动态加载服务的路由
        aliyun.custom_addon:  "proxy"
        # 每台vm 部署一个该镜像的容器
        aliyun.global:  "true"
        #  前端绑定SLB
        aliyun.lb.port_80: tcp://proxy_test:80
    environment:
        #  支持加载路由的后端容器的范围，"*"表示整个集群，默认为应用内的服务
        ADDITIONAL_SERVICES:  "*"
appone:
    ports:
        -  80/tcp
        -  443/tcp
    image:  'nginx:latest'
    labels:
        #  此处支持http/https/ws/wss  协议
        aliyun.proxy.VIRTUAL_HOST:  "http://appone.example.com"
    restart:  always
</code></pre>
<p>以下模板作为一个客户端，访问应用服务<code>appone</code>，但是它的访问路径是请求访问负载均衡服务<code>lb</code>，然后再反向代理到应用服务<code>appone</code>的。</p>
<pre><code>restclient: # 模拟rest服务消费者
  image: registry.aliyuncs.com/acs-sample/alpine:3.3
  command: "sh -c 'apk update; apk add curl; while true; do curl --head http://appone.example.com; sleep 1; done'" #访问rest服务，测试负载均衡
  tty: true
  external_links:
    - "proxy:appone.example.com" #指定link的服务的域名，以及该域名的别名
</code></pre>
<p>在服务<code>restclient</code>的容器中，你会发现域名<code>appone.example.com</code>是解析到负载均衡服务<code>lb</code>的所有容器IP的。</p>
<pre><code>/ # drill appone.example.com
;; -&gt;&gt;HEADER&lt;&lt;- opcode: QUERY, rcode: NOERROR, id: 60917
;; flags: qr rd ra ; QUERY: 1, ANSWER: 3, AUTHORITY: 0, ADDITIONAL: 0
;; QUESTION SECTION:
;; appone.example.com.  IN      A
;; ANSWER SECTION:
appone.example.com.     600     IN      A       172.18.3.4
appone.example.com.     600     IN      A       172.18.2.5
appone.example.com.     600     IN      A       172.18.1.5
;; AUTHORITY SECTION:
;; ADDITIONAL SECTION:
;; Query time: 0 msec
;; SERVER: 127.0.0.11
;; WHEN: Mon Sep 26 07:09:40 2016
;; MSG SIZE  rcvd: 138
</code></pre>
<h1>配置监控页面示例</h1>
<pre><code>lb:
    image:  registry.aliyuncs.com/acs/proxy:0.5
    ports:
            -  '80:80'
            -  '127.0.0.1:1935:1935'       # 监控页面对公网暴露的端口，有安全风险，请谨慎配置
    restart:  always
    labels:
        aliyun.custom_addon:  "proxy"
        aliyun.global:  "true"
        aliyun.lb.port_80: tcp://proxy_test:80
    environment:
        ADDITIONAL_SERVICES:  "*"
        STATS_AUTH: "admin:admin"         # 监控时用于登录的账号和密码，可以自定义
        STATS_PORT: "1935"                # 监控使用的端口，可以自定义
appone:
    expose:
        -  80/tcp
    image:  'nginx:latest'
    labels:
        aliyun.proxy.VIRTUAL_HOST:  "http://appone.example.com"
    restart:  always
</code></pre>
<p>登录到自定义路由镜像所在的每一台机器（每一台机器都可能接收请求，不管应用容器在哪台机器上面），请求 acs/proxy 健康检查页面，注意按照应用模版的<code>STATS_AUTH</code>环境变量配置正确的用户名和密码，如下所示。</p>
<pre><code>root@c68a460635b8c405e83c052b7c2057c7b-node2:~# curl -Ss -u admin:admin 'http://127.0.0.1:1935/' &amp;&gt; test.html
</code></pre>
<p>将页面 test.html 拷贝到有浏览器的机器，用浏览器打开本地文件 test.html，查看stats监控统计页面，显示为绿色，表示acs/proxy容器到后端容器的网络是连通的，在正常工作，显示为其他颜色则为异常。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 14:58:54</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e8%b4%9f%e8%bd%bd%e5%9d%87%e8%a1%a1/" title="负载均衡">负载均衡</a>, <a href="https://www.iamivan.net/tag/docker/" title="docker">docker</a>, <a href="https://www.iamivan.net/tag/%e5%ae%b9%e5%99%a8%e6%9c%8d%e5%8a%a1/" title="容器服务">容器服务</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%8f%91%e7%8e%b0/" title="服务发现">服务发现</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>阿里云容器服务--自定义路由和负载均衡策略的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRdDLqz.html" rel="bookmark">自定义路由和负载均衡策略镜像acs&sol;proxy 参考文档</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				自定义路由-使用手册 acs/proxy 自定义代理镜像,通过 FROM dockercloud/haproxy 的方式继承自镜像 dockercloud/haproxy,动态感知容器的状态,做到后端容器负载均衡代理和服务发现.特点是将 HAProxy 负载均衡软件的所有配置都参数化了,方便您自定义自己的需求和配置. 该镜像主要用于 Alibaba Cloud 容器服务的默认路由服务不能满足您需求的场景,方便您对 HAProxy 进行自定义配置. 文档中会提到 acs/proxy 和 HAPro			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1r9Lop.html" rel="bookmark">阿里云容器服务TCP的负载均衡配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阿里云容器服务在使用的过程中,针对TCP负载均衡的场景,会遇到这样的问题:如果一个应用的客户端镜像和服务端镜像均部署在同一个节点(ECS)上面,由于受SLB的限制,该应用的客户端不能通过SLB访问本机的服务端.本文试图以常用的基于TCP协议的redis为例,逐步深入的方式来解决这个问题,同时带大家了解一下容器服务的概念. 解法一:通过调度容器,避免客户端和服务端容器部署在同一个节点 示例应用模板(使用了lb标签,和swarm fileter功能) redis-master: ports: - 6			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEJ4Q6M.html" rel="bookmark">利用阿里云容器服务实现自定义节点伸缩</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介 阿里云容器服务很早就提供了基于集群CPU/内存的平均使用量触发节点自动伸缩功能,帮助许多客户自如应对业务压力的弹性变化.其原理是利用阿里云的云监控能力,在资源使用(cpu和memory)达到阈值时,触发节点伸缩. 同时还有一些企业级用户希望根据自身的监控数据和逻辑判断是否进行扩容和缩容操作,甚至可以按照固定时间进行节点扩容和缩容,针对这种场景,就需要调用的是扩容或者缩容触发器. 容器服务目前提供创建节点触发器的功能,调用节点触发器,并可以利用openAPI查看扩容出来的ECS节点方便管理和			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZE1eop.html" rel="bookmark">阿里云容器服务测评</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 为了集中精力在上层逻辑,我们计划将自己搭建的容器调度框架mesos+marathon逐步迁移至阿里云容器服务.经过一个月的测试.迁移和开发,我们已将测试环境所有服务迁移到容器服务,并针对容器服务的问题,做了很多workaround,最终在容器服务上搭建了一个高可用零宕机的容器环境.下面我们从&lt;云计算十字真言及其在小博无线的实践&gt;中提到的五个维度来谈一谈容器服务的亮点和它的不足,以及如何让其变得高可用. 冗余 服务无论是被内部还是外部请求调用,都需要通过冗余来避免单点,防止单点故障时造成的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDeKRXb.html" rel="bookmark">阿里云容器服务飞天敏捷版详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 飞天敏捷版深度整合了Docker商业版套件和阿里的容器服务,成为国内唯一具有全商业版支持能力的容器云平台,可以部署在客户自有数据中心,包含从容器的创建到运行以及镜像的全生命周期管理.飞天敏捷版另外提供开放的接口,全面兼容Docker原生API和命令行以及第三方工具,为客户提供敏捷.弹性.开放的容器云平台.借助阿里云在公共云和专有云方面的积累,飞天敏捷版更提供了独特的混合云管理模式,让客户轻松管理云上云下运行环境. 飞天敏捷版的架构可以用下图表示: 从图中我们可以看到,飞天敏捷版底层基于Do			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p56mmqz.html" rel="bookmark">区块链Hyperledger Fabric在阿里云容器服务Kubernetes中的进阶使用技巧（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们在支持用户在阿里云容器服务Kubernetes集群中使用容器服务区块链Hyperledger Fabric配置部署解决方案.或者使用自建的基于Hyperledger Fabric的区块链方案的过程中,逐渐积累了一些相关的进阶使用经验.技巧和最佳实践,涵盖了系统设计.资源规划.服务使用.错误诊断.运营维护等方面,适用于区块链Hyperledger Fabric应用和方案的开发测试.以及生产部署等用途.这些内容将以系列文章的形式陆续发布并更新,同时欢迎有兴趣.有经验的朋友不吝指正. 利用区块链解			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYRAj5p.html" rel="bookmark">在阿里云容器服务上开发基于Docker的Spring Cloud微服务应用（五）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				服务智能路由 本文为阿里云容器服务Spring Cloud应用开发系列文章的第五篇,讨论如何利用Spring Cloud 对 Netflix Zuul支持,完成服务的职能路由功能. 一.在阿里云容器服务上开发Spring Cloud微服务应用 二.部署Spring Cloud应用示例 三.服务发现 四.服务间通信与集成 五.服务智能路由(本文) 六.集中配置管理 七.高可用和容错 八.监控和日志 九.服务的部署和发布策略 使用Zuul构建简单API Gateway 在手机端完成一个功能有可能需要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW2dwEb.html" rel="bookmark">当Docker遇到数据库：在阿里云容器服务中使用RDS</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Docker与持久化服务 最近一段时间以来,微服务架构和Docker成为了技术社区的&quot;网红&quot;.其背后的原因是将微服务与Docker的结合在一起对现有的软件生命周期从架构设计.开发测试到运维迭代构成了一种&quot;颠覆性&quot;的力量:微服务鼓励开发者将整个软件解构为较小的功能组件:每个组件能够独立开发.运维.伸缩和容错:组件之间通过标准的服务接口进行通信,而组件可以选择最适合的技术栈来实现.而容器技术进一步拓展了这种解耦性,它能够将软件与其部署环境分离,利用容器敏捷和可移植的使得			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN7mJWp.html" rel="bookmark">阿里云容器服务简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				容器服务是阿里云在2015年12月推出的一项新产品,目前正处于公测阶段.   容器服务是一项高性能可扩展的容器管理服务,支持在一组阿里云云服务器上通过 Docker容器来部署或编排应用.用户不再需要安装.运维.扩展自己的集群管理基础设施,而是可以直接通过阿里云控制台图形化界面或API进行容器操作和生命周期管理.容器服务整合了阿里云负载均衡SLB.专有网络 VPC等云产品,为云应用部署与运维场景提供丰富的一站式功能支持.   和业内同类容器服务产品AWS EC2 Container Service			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2WvMd.html" rel="bookmark" class="title">关注衬线使用上的细节：不益使用过强的渐变</a>
					<div>
						之前就很想写这样一个很无聊的技术性文章,我这块只是在技术当中也不算是一个码活,靠的就是细致还有很多与生俱来的审美能力,以及不屈不挠的耐心和沉着. 说不出来很多废话,下面来看我的一些比较粗浅的总结 这是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVXlnM.html" rel="bookmark" class="title">添加描文本的技巧分析</a>
					<div>
						网站优化必定需求进行网站内容的更新,而在网站更新中必定会增加锚文本链接.许多人都晓得在一篇文章中不要增加太多的锚文本链接,也不要对同一个词语增加重复的锚文本链接,可是这些人并不晓得为什么要这么做.公司 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbakP2p.html" rel="bookmark" class="title">让iframe框架实现自动高度</a>
					<div>
						让iframe框架实现自动高度,参考代码如下:   &lt;iframe name=&quot;pindex&quot; src=&quot;about:blank&quot; scrolling=& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBlK9p.html" rel="bookmark" class="title">使用asp&period;net2&period;0中的SiteMap中的一些问题</a>
					<div>
						asp.net|sitemap|问题 SiteMap,网站地图,在网站建设的时候是很有用的.它可以直接绑定在Men和TreeView控件上,还有一个指示当前路径的SiteMapPath控件,也可以直接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6KNVz.html" rel="bookmark" class="title">Windows 2000蓝屏死机之STOP对症下药</a>
					<div>
						从理论上讲,纯32位的Windows 2000是不会出现死机的,但是这仅仅是理论上.病毒或硬件和硬件驱动程序不匹配等原因将造成Windows2000的崩溃,当Windows 2000出现死机时,显示器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7X17b.html" rel="bookmark" class="title">算法题：逆波兰表达式（数学逆波兰表达式和交并集逆波兰表达式）</a>
					<div>
						一.前言 在通常的表达式中,二元运算符总是置于与之相关的两个运算对象之间,所以,这种表示 法也称为中缀表示.每一运算符都置于其运算对象之后,称为后缀表达式,后缀表达式又叫做逆波兰表达式. 它的优势在于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPN1R1b.html" rel="bookmark" class="title">WebSphere Integration Developer 指导教程 第2部分</a>
					<div>
						WebSphere Integration Developer 指导教程 第2部分 使用WebSphere Integration Developer进行SOA开发 以面向服务的方式构建应用程序 在本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKyKNp.html" rel="bookmark" class="title">Win8&period;1系统Wpprecorder&period;sys故障导致蓝屏怎么办？</a>
					<div>
						Win8.1系统Wpprecorder.sys故障导致蓝屏怎么办?   具体方法: 1.进入Win8.1恢复环境(WINRE)环境(在自动修复失败之后会出现蓝色底菜单选项),高级选项菜单,打开命令提示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBPELz.html" rel="bookmark" class="title">海尔理财小金链上线 年化收益7&percnt; 今上午10点正式开抢</a>
					<div>
						近一年来,随着阿里.百度.腾讯纷纷进军互联网金融,一些集团巨头和资本大鳄也纷纷涉足互联网金融行业. 今年1月底,海尔集团推出了&quot;海融易&quot;理财平台,由海尔集团全资控股成立,此前已经上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywklJz.html" rel="bookmark" class="title">标准-请懂计算机的帮忙估算一下，我鼠标连续移动一秒，计算机要花费多少时间在鼠标移动这一事件的处理上</a>
					<div>
						问题描述 请懂计算机的帮忙估算一下,我鼠标连续移动一秒,计算机要花费多少时间在鼠标移动这一事件的处理上 以市面上普通正常的计算机标准大概估算一下就行了,只要误差在一个数量级以内,一直觉得计算很快,但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZnOxb.html" rel="bookmark" class="title">基于GDAL的线数据保存</a>
					<div>
						保存数据的第一步是要把数据解析出来,然后根据GDAL的规则进行数据point类型的shapefile数据生成.大概步骤为: 一.定义保存点要素数据的类 这里定义了两个基类: //基类,保存要素类型,点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA754nz.html" rel="bookmark" class="title">微软剑桥联合推出 DeepCoder 系统；谷歌工程师用&OpenCurlyDoubleQuote;买芒果&rdquo;理论解释机器学习 &vert;开发者头条</a>
					<div>
						微软剑桥联合推出 DeepCoder 近日AI研习社获悉,微软和剑桥大学的研究员近日发布了一篇介绍&quot;会编程的机器学习系统--DeepCoder&quot;的论文.据介绍,DeepCoder系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRRmRp.html" rel="bookmark" class="title">《Android应用开发攻略》&mdash;&mdash;2&period;13 用KeyListener控制输入</a>
					<div>
						2.13 用KeyListener控制输入 Pratik Rupwal2.13.1 问题 你的应用程序包含少数文本框,希望在这些文本框中限制用户仅能输入数字:而且,在某些情况下,你希望仅允许输入数字. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZRQmz.html" rel="bookmark" class="title">广电总局强推自主操作系统 业内称对电视盒子影响较小</a>
					<div>
						中介交易 SEO诊断淘宝客 站长团购 云主机 技术大厅 每经记者 孙卫涛 蒋佩芳发自北京.上海 监管部门对电视盒子的管制再度收紧.日前,国家新闻出版广电总局发布通知,要求有线电视网络公司大力开展TVO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDNQxz.html" rel="bookmark" class="title">72期：一分钟了解阿里云产品，看别人如何靠域名赚亿元</a>
					<div>
						云周刊 本周要点 查看更多 [活动回顾]大数据助力驴妈妈自助游,精准运营之道 第3期在线培训已经于3月11日上午顺利结束!本次分享嘉宾为驴妈妈副CTO邵汉成,分享主题围绕驴妈妈架构系统.数据库等内容展 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd1R4b.html" rel="bookmark" class="title">&lbrack;MySQL 特性&rsqb; MySQL5&period;6&period;7 对压缩表的改进</a>
					<div>
						5.6.7已经RC,其中关于压缩表部分,引进了大多数Facebook的改进 1.可配置的zlib压缩级别 innodb_compression_level 用于动态调整zlib的压缩级别,从1-9,默 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12Zaap.html" rel="bookmark" class="title">button&lowbar;click自动事件报错</a>
					<div>
						问题描述 各位大神们以下代码我放在button2_click事件里,但是,我将这段代码直接放在InitializeComponent()后面就报错这边我是先使用button2.click然后再使用bu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmB5laz.html" rel="bookmark" class="title">java语言怎么反转字符</a>
					<div>
						问题描述 java语言怎么反转字符 各位大神帮帮忙,怎么用java把 To be or not to be 变成 oT eb ro ton ot eb ? 解决方案 String str = &quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYYZ8b.html" rel="bookmark" class="title">php分页函数示例代码分享&lowbar;php实例</a>
					<div>
						分享一例php分页函数代码,用此函数实现分页代码很不错. 代码,php分页函数. 复制代码 代码如下: &lt;?php/** Created on 2011-07-28* Author : LKK  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKLVWM.html" rel="bookmark" class="title">Windows下安装Memcached的步骤说明&lowbar;php技巧</a>
					<div>
						(其实在Windows下安装还是比较简单的) 源码包准备: 1,memcached 1.2.1 for Win32 binaries 这个是 Win32 服务器端的 memcached 最新版本,直接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqW07Zz.html" rel="bookmark" class="title">使用Python脚本操作MongoDB的教程&lowbar;python</a>
					<div>
						连接数据库 MongoClient VS Connection class MongoClient(pymongo.common.BaseObject) | Connection to MongoDB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVDgwz.html" rel="bookmark" class="title">js动画&lpar;animate&rpar;简单引擎代码示例&lowbar;javascript技巧</a>
					<div>
						用惯了jquery的同学,相信都很欣赏其动画引擎.确实相对比较完善!如果,如果想像力足够丰富的话,相信可以做出超出想像的效果.当然,跟2d库比起来,还是相差相当一段距离.jquery压根也不是专门为动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxEmLPp.html" rel="bookmark" class="title">Silk Mobile &ndash; 缩水移动应用的测试周期</a>
					<div>
						Micro Focus已将从Borland接管的Silk Mobile?投放到市场,作为一种新的强大的移动应用测试解决方案,它将使企业能够开发出更先进更可靠的移动商业软件. 作为市场上最完整的移动应用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxEqqmp.html" rel="bookmark" class="title">如何实现android与PC视频聊天</a>
					<div>
						问题描述 如何实现android与PC视频聊天 主要是android部分 实现这个功能需要用到什么知识(不适用第三方) 解决方案 android实现PC到手机的SOCKET通信 解决方案二: 不用第三 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bByKaJz.html" rel="bookmark" class="title">用java做ip查询软件</a>
					<div>
						问题描述 请各位大哥帮帮忙,小弟初来,用java或者c#做一个ip查询软件怎么做.要求实现功能,能查询本机或者局域网内ip..谢谢! 解决方案 解决方案二:publicstringGetClientI ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmR6NDz.html" rel="bookmark" class="title">帮忙看下报错是什么问题</a>
					<div>
						问题描述 publicclassuser{privatestring_name;privatestring_name1;publicstringname{set{_name=value;}get{re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn47Qob.html" rel="bookmark" class="title">ZTreeWin v2&period;1&period;093发布</a>
					<div>
						迎接一个崭新的2011,特发布 zTree v2.1 正式版.这次修正的 Bug 主要是针对拖拽问题,并且将拖拽的功能做了一定的调整:同时还专门增加了自定义控件的接口,用户可以随心所欲使用zTree了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baqqLqb.html" rel="bookmark" class="title">java类的问题-在eclipse的环境下怎么关我创建的Frame</a>
					<div>
						问题描述 在eclipse的环境下怎么关我创建的Frame package windows; import java.awt.Frame; /** 游戏窗口类 @author ASUS * */ pu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baqNNgb.html" rel="bookmark" class="title">docker和传统Linux下多用户多任务，有什么区别？</a>
					<div>
						问题描述 A:docker和传统Linux下多用户多任务,有什么区别?该问题来自CSDNDocker技术交流群(303806405),由版主xinshubiao整理.更多0 解决方案 解决方案二:B: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9Ne23p.html" rel="bookmark" class="title">三星手机业务在美国的广告支出为4&period;01亿美元</a>
					<div>
						超过苹果的3.33亿美元.巨额广告支出使得三星在全球智能手机大战中获得了巨大的领先优势.随着竞争对手间技术差距的缩小,广告的重要性日趋突出.T-Mobile USA首席营销官迈克尔·西韦特(Micha ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
